%define __spec_install_post %{nil}
%define modulename squidrealmonitor
%define realname sq-real-mon
%define webmindir %{_libexecdir}/webmin
%define webminconfdir %{_sysconfdir}/webmin
%define webminstatedir %{_localstatedir}/webmin

Summary: Webmin module for real time Squid monitoring
Name: wbm-%{modulename}
Version: 1.0
Release: 1.b
Requires: squid
Requires(pre): /bin/sh /usr/bin/perl
Requires(pre): webmin >= 1.220
AutoReq: 0
License: GPL
Group: System/Tools
URL: http://squidrealmon.sf.net/
Source: %{realname}.wbm.gz
BuildRoot: %{_tmppath}/%{name}-%{version}
BuildArch: noarch

%description
Webmin module for Squid real time monitoring in RPM format.

%prep
%setup -q -n %{realname}-%{version}

%build
(find . -name .svn ; find . -name .xvpics ; find . -name '*.bak' ; find . -name '*~' ; find . -name '*.rej' ; find . -name core) | xargs rm -rf
(find . -name '*.cgi' ; find . -name '*.pl') | perl -ne 'chop; open(F,$_); @l=<F>; close(F); $l[0] = "#!/usr/bin/perl$1\n" if ($l[0] =~ /#!\S*perl\S*(.*)/); open(F,">$_"); print F @l; close(F)'
(find . -name '*.cgi' ; find . -name '*.pl') | xargs chmod +x

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

mkdir -p %{buildroot}%{webmindir}/%{realname}
cp -rp * %{buildroot}%{webmindir}/%{realname}
echo rpm > %{buildroot}%{webmindir}/%{realname}/install-type

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%post
# Copy config file to /etc/webmin
os_type=`grep "^os_type=" %{webminconfdir}/config | sed -e 's/os_type=//g'`
os_version=`grep "^os_version=" %{webminconfdir}/config | sed -e 's/os_version=//g'`
perl %{webmindir}/copyconfig.pl $os_type $os_version %{webmindir} %{webminconfdir} %{realname}

# Update the ACL for the root user, or the first user in the ACL
grep "^root:" %{webminconfdir}/webmin.acl >/dev/null
if [ "$?" = "0" ]; then
	user=root
else
	user=`head -1 %{webminconfdir}/webmin.acl | cut -f 1 -d :`
fi
mods=`grep $user: %{webminconfdir}/webmin.acl | cut -f 2 -d :`
echo $mods | grep " %{realname}" >/dev/null
if [ "$?" != "0" ]; then
	grep -v ^$user: %{webminconfdir}/webmin.acl > %{webminconfdir}/webmin.acl.tmp
	echo $user: $mods %{realname} > %{webminconfdir}/webmin.acl
	cat %{webminconfdir}/webmin.acl.tmp >> %{webminconfdir}/webmin.acl
	rm -f %{webminconfdir}/webmin.acl.tmp
fi

rm -f %{webminconfdir}/module.infos.cache

# Run post-install function
cd %{webmindir}
WEBMIN_CONFIG=%{webminconfdir} WEBMIN_VAR=%{webminstatedir} %{webmindir}/run-postinstalls.pl %{realname}

# Run post-install shell script
if [ -r "%{webmindir}/%{realname}/postinstall.sh" ]; then
	cd %{webmindir}
	WEBMIN_CONFIG=%{webminconfdir} WEBMIN_VAR=%{webminstatedir} %{webmindir}/%{realname}/postinstall.sh
fi

%preun
# Run the pre-uninstall script, if we are not upgrading
if [ "$1" = "0" -a -r "%{webmindir}/%{realname}/uninstall.pl" ]; then
	cd %{webmindir}
	WEBMIN_CONFIG=%{webminconfdir} WEBMIN_VAR=%{webminstatedir} %{webmindir}/run-uninstalls.pl %{realname}
fi
true

%files
%defattr(-,root,root)
%doc README
%{webmindir}/%{realname}

%changelog
* Thu Oct 24 2011 Giuseppe Ragusa <giuseppe.ragusa@fastmail.fm> 1.0-1.b
- First attempt at packaging for RHEL6 (tested on CentOS6) based on makemodulerpm.pl

